#!/usr/local/bin/apl --script
 ⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝
⍝
⍝ assert 2016-11-08 10:16:26 (GMT-5)
⍝
⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝

∇assert∆setup pgm;rc;et;r
  ⍝ Function to setup for unit tests
  ⍞←'      ',pgm,⎕tc[3]
  (rc et r)←⎕ec pgm
  →(0≠rc)/0
  ⍞←r
∇

∇assert∆message msg
  ⍝ Simple (minded) function to display a message
  ⍞←msg,⎕tc[3]
∇

∇result assert∆toScreen test
  ⍝ Function performs test and prints result to screen.
   ⍞←'      ',test,⎕tc[3]
   →(result assert∆01 ⍎test)/yes
 no:
   ⍞←'test failed.',⎕tc[3]
   →0
 yes:
   ⍞←'test succeeded.'⎕tc[3]
   →0
∇

∇b←result assert∆return test
   ⍝ Function performs tests and returns its comparison to result.
   ⍞←'      ',test,⎕tc[3]
  b←result assert∆01 test
∇

∇err assert∆error test
  ⍝ Function to test that an error is raised
∇  

∇b← result assert∆01 test
 ⍝ Helper function to recursively evaluate nested test results
 →((≡test)≠≡result)/no
 →((⍴⍴test)≠⍴⍴result)/no
 →((⍴test)≠⍴result)/no
 →(1<≡test)/test_many
 →(0≠⍴⍴test)/t2
 t1:
 b←test=result
 →0
 t2:
 →(b←∧/(,test)=,result)/0
 →no
 test_many:
 →(b←∧/test assert∆01 ¨ result)/0
 no:
 b←0
 →0
∇

True←1
False←0
