#! /usr/local/bin/apl --script
 ⍝ ********************************************************************
 ⍝   $Id: $
 ⍝ $desc: Script to test util workspaces $
 ⍝ ********************************************************************

⍝ Copyright (C) 2016 Bill Daly 

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

)copy 1 util

⍞←'util∆helpFns       : ',⎕av[11]
⍞←⊃util∆helpFns ¨ ⊂[2] ⎕nl 3
⍞←(79⍴'*'),⎕av[11]

⍞←'util∆numberp ?100  : '
⍞←util∆numberp ?100
⍞←⎕av[11],(79⍴'*'),⎕av[11]

⍞←'util∆numberp 5?100  : '
⍞←util∆numberp 5?100
⍞←⎕av[11],(79⍴'*'),⎕av[11]

⍞←'util∆numberp ''Test string''  : '
⍞←util∆numberp 'Test string'
⍞←⎕av[11],(79⍴'*'),⎕av[11]


⍞←'''Wood'' util∆over ''Bill''    : '
⍞←'Wood' util∆over 'Bill'
⍞←⎕av[11],(79⍴'*'),⎕av[11]


⍞←'util∆trim ''   A  string        '' : '
⍞←'*',(util∆trim '   A  string        '),'*'
⍞←⎕av[11],(79⍴'*'),⎕av[11]


⍞←'util∆trim ⊃''   Line one    '' ''  Line two'' ''Line three    '' : '
⍞←util∆trim ⊃'   Line one    ' '  Line two' 'Line three    '
⍞←⎕av[11],(79⍴'*'),⎕av[11]


⍞←'3 17 25 util∆sub 25 4 ⍴ ⍳ 100   : ',⎕av[11]
⎕←3 17 25 util∆sub 25 4 ⍴ ⍳ 100
⍞←⎕av[11],(79⍴'*'),⎕av[11]


⍞←'3 17 25 util∆sub ⍳25            : '
⍞←3 17 25 util∆sub ⍳25
⍞←⎕av[11],(79⍴'*'),⎕av[11]


⍞←'''/'' util∆split ''one/two/three/four/five/sixteen''',⎕av[11]
⍞←'/' util∆split 'one/two/three/four/five/sixteen'
⍞←⎕av[11],(79⍴'*'),⎕av[11]

⍞←'''/'' util∆join ''one'' ''two'' ''three'' ''four'' ''five'' ''sixteen''',⎕av[11]
⍞←'/' util∆join 'one' 'two' 'three' 'four' 'five' 'sixteen'
⍞←⎕av[11],(79⍴'*'),⎕av[11]

⍞←'util∆import∆numbers ''/'' util∆split ''45/(16,738.80)/187/0.006/10,510     '' :',⎕av[11]
⍞←util∆import∆numbers '/' util∆split '45/(16,738.80)/187/0.006/10,510'
⍞←⎕av[11],(79⍴'*'),⎕av[11]


